Last Comment Bug 520610 - E-mails (.eml) saved will not open from Finder
: E-mails (.eml) saved will not open from Finder
Status: RESOLVED FIXED
: fixed-seamonkey2.0.3, regression
Product: SeaMonkey
Classification: Client Software
Component: OS Integration (show other bugs)
: Trunk
: PowerPC Mac OS X
: -- normal (vote)
: seamonkey2.1a1
Assigned To: Stefan [:stefanh]
:
:
Mentors:
Depends on: 521699
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-05 12:55 PDT by Michael Graubart
Modified: 2010-12-27 09:19 PST (History)
3 users (show)
kairo: wanted‑seamonkey2.0+
kairo: blocking‑seamonkey2.0.3-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Make launch services aware of .eml files (1.04 KB, patch)
2010-01-24 09:18 PST, Stefan [:stefanh]
mnyromyr: review+
kairo: approval‑seamonkey2.0.3+
Details | Diff | Splinter Review

Description Michael Graubart 2009-10-05 12:55:23 PDT
User-Agent:       Mozilla/5.0 (Macintosh; U; PPC Mac OS X 10.4; en-US; rv:1.9.1.4pre) Gecko/20090903 SeaMonkey/2.0b2
Build Identifier: Mozilla/5.0 (Macintosh; U; PPC Mac OS X 10.4; en-US; rv:1.9.1.4pre) Gecko/20090903 SeaMonkey/2.0b2

If a received e-mail is saved as a file in any of the three formats (Mail File, HTML, Text File), it cannot be opened by double-clicking or dragging it to the SM icon in SM 2.

If saved as Mail or Text, it can be opened by starting SM and choosing 'Open file' from the File menu. 

If saved as HTML, it can be opened in the same way but appears empty.This is the reverse of what happens in the current stable release, SM 1.1.18: in this, the HTML option is the only one that opens (NOT empty) by double clicking.

Reproducible: Always

Steps to Reproduce:
1. Save a received e-mail as a file in one of the three available formats.
2. Double-click or drag to SM icon.
3. Alternatively, start SM, go to File menu, choose 'Open file' and locate the saved e-mail.
Actual Results:  
Double-clicking or dragging will not open the file in any of the three formats. 'Open file'opens all of them, but the HTML one is empty.

Expected Results:  
All three should open on double clicking, and I assume that the HTML one should contain the substance of the e-mail like the others.

Mac G4 (PPC), OS X 10.4.11
Comment 1 Serge Gautherie (:sgautherie) 2009-10-12 09:29:35 PDT
Can you reproduce with SeaMonkey v2.0rc1?
Or Thunderbird v3.0b4?
Comment 2 Stefan [:stefanh] 2009-12-27 11:48:09 PST
Michael,

This should be fixed in the forthcoming 2.0.2 release. Once you run 2.0.2, would you mind checking if it's fixed?
Comment 3 Michael Graubart 2009-12-28 09:55:54 PST
Stefan, 

Yes, of course I'll do that. When is 2/0/2 likely to be out?
Comment 4 Stefan [:stefanh] 2009-12-28 14:03:41 PST
> Yes, of course I'll do that. When is 2/0/2 likely to be out?

Thanks :-) I think it will be released in february. If you like pre-release builds, the build at http://ftp.mozilla.org/pub/mozilla.org/seamonkey/nightly/latest-comm-1.9.1/ should have the fix (there are new builds there every night - "2.0.2pre" builds).
Comment 5 Michael Graubart 2010-01-03 12:07:17 PST
Re Comment #4: I have just tried the pre-release 2.0.2pre version. Saved webpages and saved e-mails now open by double-clicking and by File > Open file, whether SM is running or not, on my Mac G4 (PPC) with OSX 10.4.11.

Neither with this nor with 2.0.1, will saved files or e-mails open by dragging them to the SM icon — again whether SM is running or not.
Comment 6 Stefan [:stefanh] 2010-01-03 13:49:25 PST
I can't open .eml files, but .txt and .xhtml files opens fine when I drag them to the SM icon in the dock. You're sure that the icon was the pre-release (probably, but just to double-check)?
Comment 7 Stefan [:stefanh] 2010-01-03 13:53:59 PST
Regarding the e-mail file, it could be that it's not in our info.plist.in file.
Comment 8 Stefan [:stefanh] 2010-01-03 13:54:51 PST
(In reply to comment #6)
> I can't open .eml files, but .txt and .xhtml files opens fine when I drag them
> to the SM icon in the dock. You're sure that the icon was the pre-release
> (probably, but just to double-check)?

Mac OS 10.5.8 (Intel)
Comment 9 Michael Graubart 2010-01-04 04:29:17 PST
Stefan: Yes, it was the pre-release one (Build identifier: Mozilla/5.0 (Macintosh; U; PPC Mac OS X 10.4; en-US; rv:1.9.1.8pre) Gecko/20100103 SeaMonkey/2.0.2pre). I have explored this further. E-mails are saved as .eml files, regardless of what choice is made by Command > S. They all open by double-clicking or via 'File > Open file', but not by dragging. But if I manually change the file-termination of any of them to .txt, it opens by dragging as well as by the other methods. Should the four choices offered under Command > S (i.e. Mail Files, All Files, HTML, Text Files) not automatically append the appropriate terminations?

Under File > Save As..., only two choices are offered: File and Template. File still saves as .eml.
Comment 10 Stefan [:stefanh] 2010-01-10 07:30:04 PST
For the save as problem, see bug 514497 and its dependencies.
Comment 11 Stefan [:stefanh] 2010-01-13 05:32:23 PST
Confirming this. I think I can come up with a fix for this, but I need to read through the apple specs a bit more.
Comment 12 Stefan [:stefanh] 2010-01-24 09:18:02 PST
Created attachment 423242 [details] [diff] [review]
Make launch services aware of .eml files

OK, so this patch will make .eml files open in SeaMonkey from the Finder (dragging & double-clicking etc). Note that they will open in the browser, unless explicity opened from mailNews (works like this on windows too).

Basically, the patch makes Launch Services register that SeaMonkey can open .eml files. One effect is that if you right-click an .eml file and choose "Open with...", SeaMonkey will now be in the list of suggested applications (not greyed-out).

The "CFBundleTypeOSTypes" part is a bit odd, because the types are actually some constants that was used in mac classic. It's unclear what type a .eml file belong to, so I just added the text types instead - it shouldn't matter. As of Tiger, you can specify other elements in the plist file, those will then override some of the CFBundle* stuff. But I rather fix this now with the attached patch and then eventually do a re-write of the file in a separate bug (trunk-only).
Comment 13 Stefan [:stefanh] 2010-01-26 08:25:32 PST
Putting this on the blocking radar.
Comment 14 Robert Kaiser 2010-01-26 12:55:55 PST
I don't think we should hold back a release for this, but we surely want to have the fix.
Comment 15 Stefan [:stefanh] 2010-01-30 11:57:40 PST
Comment on attachment 423242 [details] [diff] [review]
Make launch services aware of .eml files

This is a really low-risk & high-value fix.
Comment 17 Michael Graubart 2010-04-01 10:24:52 PDT
This has now become a disaster. I now cannot open a single saved e-mail (whether saved as text or 'all files') in the latest SM 2.0.5Pre in any way at all — not by double-clicking, not by dragging and dropping, not via File > Open. I believe I am not allowed to re-open this bug, but it should be resolved most urgently. There must be thousands of SM users whose work and business is now paralyzed.
Comment 18 Michael Graubart 2010-04-01 11:47:53 PDT
This is bizarre. In an attempt to open some of my saved e-mails, I downloaded SeaMonkey 2.0.4, but I cannot open my old e-mails in that version either. I have checked to the best of my ability that this is not a computer fault: I repaired all disk permissions and I ran Disk Warrior to rebuild my entire disk directory. Everything else is working on my system.I am at a complete loss.
Comment 19 Stefan [:stefanh] 2010-04-01 12:32:46 PDT
It works fine for me. I don't think your issue is related to this bug since File --> Open is unrelated to the patch here. Sounds more like you have an issue with your system. Have you tried rebuilding the Launch Services database? There are several free utilities that you can do this with, like OnyX and Maintainance. Either way, if you feel like this is really a "real" issue after re-building the Launch Services etc, please file a new bug (cc me).
Comment 20 Michael Graubart 2010-04-01 13:19:23 PDT
Thank you for the advice, Stefan. I did what you recommended (using Onyx). This had the very curious effect that all my saved e-mails (.eml) now open — in Microsoft Entourage (which I never normally use)! When I used 'Information' to make them open in SeaMonkey, they no longer opened in anything (what happens in SeaMonkey is that a dialog appears ('Do you want to open/save', etc.) and if one clicks 'Open' it goes round again in a circle. I then tried changing the termination of one of them from .eml to .html, and it then opened in SeaMonkey as unformatted and un-paragraphed text.

I should have said that the icons of most of my saved e-mails have now changed to blank ones. These do not open in SeaMonkey. But some very old ones have changed their icons to Safari ones, and these open in either SeaMonkey or Safari.
Comment 21 Michael Graubart 2010-04-01 16:49:07 PDT
Stefan, thank you for your e-mail. I cannot reply to it directly because I have lost contact with all my mail. Re-installing SM 2.0.4 did not do anything. So I went back to 20.5pre and created a new profile. That did the trick, but of course I had then lost all my addresses, bookmarks, etc. So I then transferred every file one by one from my old profile to the new, every time testing the opening of an e-mail, and finally discovered that the file that was doing the damage was mimeTypes.rdf, so I abandoned that and let SM recreate it.

I then had to recreate my mail account settings, but even though I put my old Mail folder into the new profile, its contents do not show up. Is there anything I can do?

The other curious thing is that though my most recent saved e-mails will open SM by double-clicking, etc., all my old ones still open in Entourage (though I can open them in SM by dragging and dropping) and I cannot change this behavious with 'Information'.
Comment 22 Stefan [:stefanh] 2010-04-01 17:08:30 PDT
(In reply to comment #21)
> Stefan, thank you for your e-mail. I cannot reply to it directly because I have
> lost contact with all my mail. Re-installing SM 2.0.4 did not do anything. So I
> went back to 20.5pre and created a new profile. That did the trick, but of
> course I had then lost all my addresses, bookmarks, etc. So I then transferred
> every file one by one from my old profile to the new, every time testing the
> opening of an e-mail, and finally discovered that the file that was doing the
> damage was mimeTypes.rdf, so I abandoned that and let SM recreate it.
> 
> I then had to recreate my mail account settings, but even though I put my old
> Mail folder into the new profile, its contents do not show up. Is there
> anything I can do?

What about deleting/renaming the mimeTypes.rdf in your old profile?
Comment 23 Michael Graubart 2010-04-01 17:15:03 PDT
I have not got the old profile any more, I'm afraid. I have managed to restore most of my mail now by transferring individual items like 'inbox' and 'drafts' into the mail folder in the new profile, though from a version of Mail that did not have my latest items, including your e-mail. And I was able to kill the Entourage preference in individual ones of the old e-mails, though not globally.
Thank you again very much for your help through this bit of a nightmare.
Comment 24 Michael Graubart 2010-04-15 08:23:54 PDT
The problem has come back with the latest SM 2.0.5Pre: my old saved e-mails (.eml) open in MS Entourage (which I have never used) and "Finder/File/Info./Open with/SeaMonkey/Change all" does not work. 

So (hoping to learn from the previous debacle) I first of all took mimeTypes.rdf out of my profile and kept it somewhere safe, then restarted SeaMonkey in the hope that a new mimeTypes.rdf would be created. It wasn't.

I next created a new profile. This time the saved e-mails still open in Entourage and not in SeaMonkey.

I note from Comment 22 that you, Stefan, recommended renaming mimeTypes.rdf. If I do that, wll it still work? What can I rename it to?
Comment 25 Stefan [:stefanh] 2010-04-15 11:12:00 PDT
The re-naming doesn't matter if you've tried to remove the file - it's the same thing.
Comment 26 Michael Graubart 2010-04-15 15:56:04 PDT
I also posted a question about this in the Apple discussion forums, and got a reply with a link to another source, from which the following is an extract:

'These troublesome apps don't have a value set for the CFBundleIdentifier key. If you set one, apparently the problem goes away. So how do you go about fixing this problem? Control-click on the application in question and choose Show Package Contents. Inside the Contents folder, you should see an Info.plist file. You need to open this with the Property List Editor (included with the Xcode Developer Tools) or Plist Edit Pro, or even TextEdit or some other pure-text editor. You then need to add a new key and string to the file:

 <key>CFBundleIdentifier</key>
        <string>com.foo.bar</string>

The first line is easy, as it's always the same. The second line, though, will vary by program. To try to figure out exactly what to put there, take a look in your user's Prefernces folder, and try to find the prefs file for the application in question. If the program you were trying to set up was (completely fictitious data follows) called Sneakers and was written by CoolMacWare, you might find a file called com.coolmacware.sneakers.plist in your Preferences folder. If that were the case, then the second line above would be com.coolmacware.sneakers. It's a bit of a black art, it seems.

After making this change, you need to reset the LaunchServices database. A logout/login should do the trick, or you can try this Terminal command, taken from the Apple Discussions thread:

/System/Library/Frameworks/ApplicationServices.framework/Versions/A/\
Frameworks/LaunchServices.framework/Versions/A/Support/lsregister -kill \
-r -domain system -domain local -domain user

Please note that I have not tested the above command. If everything worked right, you should now be able to use Get Info and reassign the files in question to the previously-non-usable application.'
Comment 27 Michael Graubart 2010-04-15 16:26:49 PDT
Additional information: it is not just e-mails saved in a previous SeaMonkey that open in Entourage. I have just saved an e-mail in the latest 2.0.5Pre in all the possible formats: All files, HTML, Mail files, Text files.

All four open in Entourage when double-clicked.
Comment 28 Michael Graubart 2010-04-15 16:46:54 PDT
One more piece of information: following another recommendation from the Apple discussions forums, I tried installing the preference pane RDDefaultApp-2.1.X and selecting SeaMonkey as the preferred app. for saved e-mails. It did not work.

Perhaps this bug should now be re-opened.
Comment 29 Michael Graubart 2010-04-16 05:55:59 PDT
Yet more information: in Comment 24, I observed that when I took Mimetypes.rdf out of my profile and restarted SM, Mimetypes.rdf was not recreated.

In order to confirm that this was not due to a corrupt profile, I created a new profile and again removed Mimetypes.rdf. On restarting SM, Mimetypes.rdf was again not recreated. So this is a bug in SM, not in my profile.
Comment 30 Michael Graubart 2010-04-16 11:16:24 PDT
And yet more: I have now ensured that the Apple Mail prefs. are set to make SM my preferred e-mail client and have ensured that Entourage preferences have not been set to override this, but SM still saves e-mails with actual Entourage icons. If I remove Entourage from my system,this no longer happens.
Comment 31 Michael Graubart 2010-04-18 03:05:56 PDT
Further to Comment 30: now that I have removed Entourage, e-mails saved in SM open in SM when double-clicked. The problem, it is now clear, is one of interaction between SM and Entourage, even when the latter is not running.
Comment 32 Stefan [:stefanh] 2010-04-18 04:45:12 PDT
(In reply to comment #26)
> I also posted a question about this in the Apple discussion forums, and got a
> reply with a link to another source, from which the following is an extract:
> 
> 'These troublesome apps don't have a value set for the CFBundleIdentifier key.

This is not the problem, because we have a value set for the CFBundleIdentifier key
Comment 33 Michael Graubart 2010-11-22 03:12:41 PST
Further to Comment #31, I have had to re-install Entourage on my computer because when I removed it previously, this led to all sorts of problems with downloading and installing updates to Microsoft Office. Now that I have Entourage back in my Applications folder, whenever I double-click on an e-mail saved in Seamonkey, it is once more Entourage that opens. 

I have selected Seamonkey as my preferred e-mail client via my Mac Mail application, but this has not overridden the interaction between Seamonkey and Entourage.
Comment 34 Michael Graubart 2010-11-23 01:39:15 PST
A further piece of information re Comments ##31 & 33: when I save an e-mail in Seamonkey, the saved file actually appears as an Entourage file! How can that be possible? (I never have Entourage running.)
Comment 35 Michael Graubart 2010-11-23 07:28:05 PST
Apologies re Comments ##31, 33 and 34: I've solved the problem by altering the file associations. Not a SeaMonkey bug at all.
Comment 36 Michael Graubart 2010-12-27 04:54:18 PST
Re Comment #35: I am sorry to want to re-open this bug yet again, but I have realized that this was only a very partial fix. If I use 'Information' on my Mac to change the file association to SM, this works for that individual saved e-mail. But if I click 'Change all' in order to make SM the default application for opening all .eml files, the file association snaps back to MS Entourage. I have also used an application for changing all file associations, and that has not worked either.

The situation is now that I can open a saved e-mail in SM by dragging it to the SM icon or by using 'Open with...' in the File menu, but not by double-clicking unless I have changed the file association for that individual e-mail.

At one time SM saved e-mails as SM files. It now saves them as Entourage files, a fact which defeats my limited understanding of these things.
Comment 37 Michael Graubart 2010-12-27 09:19:39 PST
Further to Comment #36: It seems to me that choosing whether to save an e-mail as HTML, Mail or 'All files' (see Seamonkey Help) is irrelevant to this situation; it is the termination that matters. If one chooses HTML, one gets the usual HTML garbage from which one has to extract the message.'Mail' and 'All files" result in Entourage files

Saving as Text circumvents the problem, but destroys any images or formatting in the e-mail.

As the problem may partly be an Apple Mac one, I have posted the following in the Apple Discussions. But as the problem was not there with earlier releases of Seamonkey, it must also be a Seamonkey problem.

"The original string of messages resulting from my question is under the topic 'Cannot set preferred application to open .eml files', but this has been archived, so I hope I can restart the discussion here.

The problem, in brief, is that my preferred browser and mail client, Seamonkey (currently 2.0.12pre; 2.0.x is the last version to work in OS X 10.4), creates Microsoft Entourage files (Why? How?) when one saves e-mails as mail files with termination .eml. These can be opened in Seamonkey either by dragging them to the Seamonkey icon or by using File > Open with..., but double-clicking starts Entourage. (If the e-mails are saved as HTML files, Safari opens.) 

In order to make saved e-mails open in Seamonkey, selecting Seamonkey by means of file assignment (in Information) only works for individual files; selecting 'Change all' makes the assignment jump back to Entourage.

In the previous string, Limnos suggested a procedure in Package Contents, involving entering a new key and string. But in Seamonkey I found that this key is already there with the correct identifier string. (The Seamonkey developers have confirmed this, too.)

Then BDAqua suggested using RCDefaultApp to re-set the default application. This does not work, either. (I have re-set the LaunchServices database, incidentally.)

It seems to me that this whole thing is not (or not only) a Seamonkey problem, because if I remove Entourage from my system, Seamonkey saves .eml files without the Entourage icon, i.e. as Seamonkey files, and there is no problem then. (I do not want to remove Entourage permanently, because doing so seems to create difficulties with MS Office updates.)"

Note You need to log in before you can comment on or make changes to this bug.